# TinyZoo/GB

This repository houses a source port of the ZZT engine to the Game Boy and Game Boy Color platforms.

Downloads and usage documentation is available [on the Wiki of Weavers](https://zeta.asie.pl/wiki/doku.php?id=release:tinyzoo).

This project is not affiliated in any way with Nintendo. "Game Boy" and "Game Boy Color" are registered trademarks of Nintendo Co., Ltd.

## Licensing

TinyZoo/GB as a complete work is licensed under the GNU General Public License, version 3 or later.

Some utility code is additionally made available under other licensing terms, such as the zlib license - check the specific files' copyright notices for more information.

Here are some clarifications provided by me to clarify the ways I expect TinyZoo/GB to be used in. **Note that only the official license text is legally binding - the clarifications below are not.**

  * As a ZZT world is a copyrightable work containing executable code, which the conversion process links statically with the game engine, publishing a world linked with TinyZoo/GB under the GPL implies that both the ZZT world and the resulting ROM images should be provided to recipients under the terms of the GPL.
    * This does not prevent you from dual-licensing them under different terms.
  * For the purposes of bundling ZZT worlds, "the preferred form of the work for making modifications to it" is considered to be the .ZZT file provided as input to the converter.
  * I do not see a problem with using TinyZoo/GB commercially; however, absent different licensing terms, users must be granted their necessary rights under the GPL.
  * I do not plan to pursue hobbyist, non-commercial usage of the publicly and freely available, unmodified TinyZoo/GB engine to distribute conversions of publicly and freely available, unmodified ZZT worlds.
    * Please do not exploit this statement. There can always be exceptions.

The terms are imposed primarily to protect the archival and preservation interests of the ZZT community - in particular, to prevent distribution of compiled ROM images without access to the underlying ZZT world source files.

If deemed necessary for your project, alternate licensing terms can be negotiated - please contact me for more information.

### License notice

Copyright (c) 2020, 2021, 2022, 2023 Adrian Siekierka

TinyZoo/GB is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

TinyZoo/GB is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with TinyZoo/GB. If not, see <https://www.gnu.org/licenses/>. 

TinyZoo/GB includes code derived from the Reconstruction of ZZT, used under the following license terms:

Copyright (c) 2020 Adrian Siekierka

Based on a reconstruction of code from ZZT,
Copyright 1991 Epic MegaGames, used with permission.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
